Index: trunk/Poubelle/archTOI.old/pisteetoile.cc
===================================================================
--- trunk/Poubelle/archTOI.old/pisteetoile.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/pisteetoile.cc	(revision 534)
@@ -8,18 +8,17 @@
 FormePulse    PisteEtoile::FPulse(Trapani);
 
-
-
-int SSTnbPasFit= (int) (2*TFExcursion/TPasTFit);
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 PisteEtoile::PisteEtoile(short NoPhotDiod) {
-	PasTempsEch=0.005836818076;			
+	PasTempsEch=archParam.acq.perEch;			
 		//BUGG doit changer	!!!!! Doit etre extrait d'un serveur de param d'acquisition
 	NoPhDiod=NoPhotDiod;
 	DiodVivante=true;
+	
+	SSTnbPasFit= (int) (2*TFExcursion/TPasTFit);
+	
 	AmplNorm=0.;
-//	On echantillonne dix fois plus fin pour avoir une bonne estimation de AmplNorm
-//	Eviter les systematiques
 	for(int i=0; i<SSTLongIndexEvt()*10; i++){
-		AmplNorm+=FPulse.PulseShape(i/10.*TPasTFit)*FPulse.PulseShape(i/10.*TPasTFit);
+		AmplNorm+=FPulse.PulseShape(i*PasTempsEch/10.)*FPulse.PulseShape(i*PasTempsEch/10.);
 	}
 	AmplNorm/=10.;
@@ -39,5 +38,4 @@
 PisteEtoile& PisteEtoile::operator =(PisteEtoile const & x) {
 	PasTempsEch=x.PasTempsEch;		
-		//BUGG doit changer	!!!!! Doit etre extrait d'un serveur de param d'acquisition
 	NoPhDiod=x.NoPhDiod;
 	DiodVivante=x.DiodVivante;
@@ -115,6 +113,6 @@
 void PisteEtoile::fill(int* pData, int InDebutPiste, int nData) {
 //	if(!isAlive()) return;
-	indexDebutPiste=InDebutPiste;
-	int* PhDiod=PhDiodArray;
+	indexDebutPiste=InDebutPiste - PhDiodTabLong + nData;
+	int* PhDiod=PhDiodArray + PhDiodTabLong - nData;
 	int* pDataC=pData;
 	for(int k=0;k<nData;k++,pDataC++, PhDiod++) (*PhDiod)=(*pDataC);
@@ -152,12 +150,19 @@
 	
 		if(testEtoile) {
-		// On emballe une etoile.
+		// On emballe une etoile
+			LastEtoile.InpCurrent= AmplRes/FPulse.GainElectrique();
+			LastEtoile.InpCurFin= AmplFin/FPulse.GainElectrique();
+			LastEtoile.TEchan=TIndex;
+			LastEtoile.TFin=Tfin;
+			LastEtoile.InpCurrNoisRMS=Vrms/FPulse.GainElectrique();
+			LastEtoile.X2Calc=X2Min;
+			LastEtoile.NoDiode=NoPhDiod;
 			LastEtoile.FitForme=SuccesAFine;
-			LastEtoile.X2Calc=X2Min;
-			LastEtoile.InpCurrNoisRMS=Vrms/FPulse.GainElectrique();
-			LastEtoile.TEchan=TIndex;
-			LastEtoile.InpCurrent= AmplRes/FPulse.GainElectrique();
-			LastEtoile.NoDiode=NoPhDiod;
 			LastEtoile.LargMiHauteur=widthHalfMax;
+			
+/*			cout<<setprecision(9);
+			cout<<TIndex<<" "<<Tfin<<" "<<AmplRes<<" "<<AmplFin<<endl;
+			cout<<TIndex-Tfin<<" "<<(AmplRes-AmplFin)/AmplFin<<endl;
+*/
 		}
 	}
@@ -199,6 +204,8 @@
 // On calcule le Vrms sur le prepulse
 	Vrms=0.;
-	for (int i=0; i<Prepulselong; i++) Vrms+=PhDiodPiste[i]*PhDiodPiste[i];
-	Vrms=sqrt(Vrms)/Prepulselong;
+	for (int i=0; i<Prepulselong; i++) {
+		Vrms+=PhDiodPiste[i]*PhDiodPiste[i];
+	}
+	Vrms=sqrt(Vrms/Prepulselong);
 	if(Vrms<SSTLsbVal) Vrms=SSTLsbVal;		// Pour eviter les VRMS=0.
 	
@@ -281,9 +288,7 @@
 // Maintenant que l'on se doute que il y a une etoile 
 // On veut connaitre son flux et son temps de passage
-// Nécessite d'avoir un ordre d'idee de la vitesse de rotation du ballon.
+// Nécessite de connaitre la vitesse de rotation du ballon.
 
 		// BUGG devra etre extrait des headers acquisition. Ca peut changer!!!!!!
-
-	
 			
 	int IndexDebutEvt=MaxIndex-SSTLargEvtIndex();
@@ -292,5 +297,6 @@
 		// Pointeur origine du tableau d'echantillon sur lequel sera calculé le fit
 	double DeltaTemps=0.;
-// Pour chaque decalage en temps, on estime un amplitude et calcule le X2
+	
+// Pour chaque decalage en temps, on estime une amplitude et calcule le X2
 	for(int k=0; k<SSTnbPasFit; k++) {
 		DeltaTemps=TFExcursion-k*TPasTFit;
@@ -314,44 +320,55 @@
 	X2Min=1.e99;
 	int X2MinIndex=-1;
-	for(int k=0; k<SSTnbPasFit; k++) 
+	for(int k=0; k<SSTnbPasFit; k++) { 
 		if (X2[k]<X2Min) {
 			X2Min=X2[k];
 			X2MinIndex=k;
 		}
-
+	}
+	
 	if((X2MinIndex>0)&&(X2MinIndex<(SSTnbPasFit-1))) {
 	
 // On fitte une parabole sur les trois X2 qui encadrent le min
-	double Di;	// Index (non entier) du minimum du X2
+		double Di;	// Index (non entier) du minimum du X2
 		double X=(X2[X2MinIndex+1]-X2Min)/(X2Min-X2[X2MinIndex-1]);		
 		Di=0.5*(X+1)/(X-1);
 
+// Le X2 est mimimum pour le n° de pas de fit X2MinIndex+Di 
 // On calcule l'amplitude estimee a ce temps
 		double Som1=0.; pFitArray=pFitArray0;
 		DeltaTemps=TFExcursion-(X2MinIndex-Di)*TPasTFit;
 		for(int i=0; i<SSTLongIndexEvt(); i++, pFitArray++) 
-			Som1+=(*pFitArray)*FPulse.PulseShape(i*PasTempsEch-DeltaTemps);
-		AmplRes=Som1/AmplNorm;
-		
-//Le X2 est mimimum pour le n° de pas de fit X2MinIndex+Di 
+				Som1+=(*pFitArray)*FPulse.PulseShape(i*PasTempsEch-DeltaTemps);
+		AmplFin=Som1/AmplNorm;
+			
+
 
 #ifdef PEtoileDebug
-		double* PulseTrak=new double [SSTLongIndexEvt()];
+		double *PulseTrak=new double [SSTLongIndexEvt()];
 #endif
-
+// On calcule le X2 correspondant
 		double X2Som1=0.; double dummy=0.;pFitArray=pFitArray0;
 		for(int i=0;i<SSTLongIndexEvt();i++,pFitArray++) {	
+		
 #ifdef PEtoileDebug
 			PulseTrak[i]=FPulse.PulseShape(i*PasTempsEch-DeltaTemps);
 #endif
-			dummy=(*pFitArray)-AmplRes*FPulse.PulseShape(i*PasTempsEch-DeltaTemps); 	// Différence
+			dummy=(*pFitArray)-AmplFin*FPulse.PulseShape(i*PasTempsEch-DeltaTemps); 	// Différence
 			X2Som1+=dummy*dummy;														// Au carré
 		}
-					
+						
 		X2Min=X2Som1/(SSTLongIndexEvt()*Vrms*Vrms);
-	
-		TIndex=indexDebutPiste+IndexDebutEvt+DeltaTemps/PasTempsEch;
-					//Ouff!!!!
+		
+		Tfin= indexDebutPiste+IndexDebutEvt+DeltaTemps/PasTempsEch;
+			//Ouff!!!!
+/*			
+		cout<<setprecision(9)<<endl;			
+		cout<<Tfin<<" "<<indexDebutPiste<<" "<<IndexDebutEvt<<" "<<DeltaTemps/PasTempsEch<<endl;
+*/		
 		SuccesAFine=true;
+		
+#ifdef PEtoileDebug
+		delete[] PulseTrak;
+#endif
 	}
 	else {				// Echec, c'est tres bizarre! On doit etre dans le bruit
Index: trunk/Poubelle/archTOI.old/pisteetoile.h
===================================================================
--- trunk/Poubelle/archTOI.old/pisteetoile.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/pisteetoile.h	(revision 534)
@@ -5,10 +5,10 @@
 #include "formepulse.h"
 
-/*	// D. Yvon, CE Saclay, 08/99
+/*	// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 	// Analyse the Photodiode track to find star pulse.
 	// Caracterise the time and amplitude of the star Pulse
 
-	We analyse a set of 32 samples. The 16 first are considered as prepulse sample.
+	We analyse a set of 48 samples. The 32 first are considered as prepulse sample.
 	On the prepulse: 
 		We compute baseline and substract it. 
@@ -17,5 +17,9 @@
 		Look for trigger
 	If triggered :
-		Look for maximum. If max found 20< Max< 28
+		Look for maximum. 
+		Compute Full width half maximum
+		Fit a paroabole on max of the pulse
+		return max fitte and time of max fitte
+	if analfine
 		Iterate time fit on pulse area and compute amplitude and X2
 		Find best X2. 
@@ -23,5 +27,5 @@
 		Build SSTStar.
 		
-	That's it. Test code tstpisteetoile.cc can be found in tstroutines folder.
+	That's it. 
 	When  done push the track eigth samples forward and iterate analysis. 
 */
@@ -39,9 +43,9 @@
 // 	Parametrisation du Trigger 
 #define SeuilGachette (6.) 				// On déclenche à SeuilGachette sigmas
-#define SSTLsbVal (10./4096)
+#define SSTLsbVal (10./4096.)
 
 //	Parametrisation Analyse Fine
 #define TFExcursion (15.e-3)			// Secondes: Excursion du fit autour de MaxIndex
-#define TPasTFit (2.5e-3)				// Secondes:
+#define TPasTFit (1.5e-3)				// Secondes:
 			// Secondes:
 
@@ -70,9 +74,12 @@
 	inline int SSTLargEvtIndex(); 
 	inline int SSTLongIndexEvt();
+	static TransFuncElec Trapani;
+	static FormePulse FPulse;
+	
 protected:
 	double PasTempsEch; 	//Secondes 
 // Idendificateur, repères et gestion 
 	short NoPhDiod;
-	int indexDebutPiste; 	// A actualiser dans push() et Fill()! BUGG!!!!
+	long indexDebutPiste; 	// A actualiser dans push() et Fill()
 	bool DiodVivante;		// Si false, On ne fait rien 
 	
@@ -88,11 +95,13 @@
 	double Vrms;
 	short MaxIndex;			// Index de l'amplitude Max en analyse Trig()
+	double TIndex;
 	double AmplMax;
+	double AmplRes;
 	int widthHalfMax;
+	int SSTnbPasFit;
 //	double integ;
 // Variables Resultat d'analyse fine
-	
-	double AmplRes;
-	double TIndex;
+	double AmplFin;
+	double Tfin;
 	double X2Min;
 	bool SuccesAFine;
@@ -109,6 +118,5 @@
 	double* X2;		//Tableau des X2 calculés
 	
-	static TransFuncElec Trapani;
-	static FormePulse FPulse;
+
 	
 };
Index: trunk/Poubelle/archTOI.old/requesthandler.h
===================================================================
--- trunk/Poubelle/archTOI.old/requesthandler.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/requesthandler.h	(revision 534)
@@ -0,0 +1,16 @@
+// requesthandler.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef REQUESTHANDLER_H
+#define REQUESTHANDLER_H
+
+#include <string>
+#include "toi.h"
+
+class RequestHandler {
+public:
+  virtual bool processTOIReq(TOI const& toi, string line)=0;
+  virtual bool processOption(string keyw, string args)=0;
+};
+
+#endif
Index: trunk/Poubelle/archTOI.old/skyposition.h
===================================================================
--- trunk/Poubelle/archTOI.old/skyposition.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/skyposition.h	(revision 534)
@@ -0,0 +1,36 @@
+// skyposition.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef SKYPOSITION_H
+#define SKYPOSITION_H
+
+class SkyPosition {
+public:
+  SkyPosition();
+  
+  void setEarthLocation(double  latitude, double  longitude);
+  void getEarthLocation(double& latitude, double& longitude) const;
+  
+  void setAltAz(double  altitude, double  azimut);
+  void getAltAz(double& altitude, double& azimut) const;
+  
+  void setEquat(double  ra, double  dec);
+  void getEquat(double& ra, double& dec);
+  
+  void setGalac(double  l, double  b);
+  void getGalav(double& l, double& b) const;
+  
+  void setTSid(double  lst);
+  void getTSid(double& lst) const;
+  
+  // void setMJD(double mjd); Pour faire proprement, garder synchro avec tsid...
+  
+protected:
+  // All this is kept in sync. Recompute from AltAz on location/tsid change.
+  double lat, long;
+  double alt, az;
+  double ra, dec;  
+  double tsid;
+};
+
+#endif
Index: trunk/Poubelle/archTOI.old/sstetoile.cc
===================================================================
--- trunk/Poubelle/archTOI.old/sstetoile.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/sstetoile.cc	(revision 534)
@@ -1,14 +1,15 @@
 #include "sstetoile.h"
+
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 void SSTEtoile::print(ofstream& str) {
 	str<<setprecision(11);
-	str<<InpCurrent<<'\t'<<TEchan<<'\t'<<NoDiode<<'\t'<<LargMiHauteur;
-	str<<'\t'<<InpCurrNoisRMS<<endl;
-	//	<<'\t'<<X2Calc<<'\t'<<FitForme
+	str<<InpCurrent<<'\t'<<InpCurFin<<'\t'<<TEchan<<'\t'<<TFin<<'\t'<<NoDiode<<'\t'<<LargMiHauteur;
+	str<<'\t'<<InpCurrNoisRMS<<'\t'<<X2Calc<<'\t'<<FitForme<<endl;
 	return;
 }
 
 string SSTEtoile::printHeader() {
-	string a("InpCurrent\tTempsEchan\tNoDiode\tLarMiHauteur\tICurrRMS\tX2Calc\tFitForme");
+	string a("InpCurrent\tInpCurFin\tTempsEchan\tTFin\tNoDiode\tLarMiHauteur\tICurrRMS\tX2Calc\tFitForme");
 	return a;
 }
Index: trunk/Poubelle/archTOI.old/sstetoile.h
===================================================================
--- trunk/Poubelle/archTOI.old/sstetoile.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/sstetoile.h	(revision 534)
@@ -1,4 +1,6 @@
 #ifndef SSTEtoile_H
 #define SSTEtoile_H
+
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 #include <stdio.h>
@@ -11,8 +13,10 @@
 public:
 	double InpCurrent;		// En Ampère
+	double InpCurFin; 		// En ampère, 	Analyse fine
 //	double IInteg;			// En Ampère
-	double TEchan;			// Temps en indexEchantillon
+	double TEchan;			// Temps en indexEchantillon analyse trig
+	double TFin;			// Temps en indexEchantillon analyse fine
 	double InpCurrNoisRMS;	// Bruit en Ampère
-	double X2Calc;			// Sans dimension
+	double X2Calc;			// Sans dimension, analyse fine
 	int NoDiode;
 	bool FitForme;			// Fit de forme?
@@ -20,5 +24,5 @@
 	
 	void print(ofstream& str);
-	string printHeader();
+	static string printHeader();
 };
 
Index: trunk/Poubelle/archTOI.old/ssthandler.cc
===================================================================
--- trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/ssthandler.cc	(revision 534)
@@ -12,11 +12,11 @@
 
 #include <math.h>
+#include <iostream>
 #include "ssthandler.h"
 #include "pisteetoile.h"
 
-#ifdef SST_DUMPLOG
+
 ofstream SSTHandler::sstchass("SSTChassLogFile");
 bool     SSTHandler::sstchassinit=false;
-#endif
 
 // diodpermut[i] = channel de la diode i
@@ -180,4 +180,17 @@
 }
 
+
+// D. Yvon, CEA/DAPNIA/SPP Saclay, 08/99
+
+
+#ifdef SSTStatLog
+	static ofstream sststat("SSTStatLog");
+	static int compteurBlock=0;
+	static int nbStar=0;
+	#include "ssthardware.h"
+	#include "archparam.h"
+#endif
+
+
 int SSTHandler::FindStars(block_type_sst* blk) {
 	NbStarInBlock=0;
@@ -224,10 +237,12 @@
 					//On empile sur la map.
 				NbStarInBlock++;
-#ifdef SST_DEBUG			
+#ifdef SSTDUMP			
 			// On écrit les pistes ayant déclénchées
 				int NoDiodeEvt=LastStar.NoDiode;
-				if(pPisteDump[NoDiodeEvt]->is_open())	
-					for(int noSamp=0; noSamp<NbSampleBlock;noSamp++)
-						(*pPisteDump[NoDiodeEvt])<<noStarDet<<'\t'<<NoDiode<<'\t'<<NoFirstSpInBlock+noSamp<<'\t'<<Diodedata[noSamp]<<endl;
+				if(NoDiodeEvt<NbChanDump) {
+					if(pPisteDump[NoDiodeEvt]->is_open())	
+						for(int noSamp=0; noSamp<NbSampleBlock;noSamp++)
+							(*pPisteDump[NoDiodeEvt])<<noStarDet<<'\t'<<NoDiode<<'\t'<<NoFirstSpInBlock+noSamp<<'\t'<<Diodedata[noSamp]<<endl;
+				}
 #endif
 				noStarDet++;
@@ -257,7 +272,6 @@
 		LastBlockStarVec.push_back((*StarHistReIter).second);
 	
-#ifdef SST_DUMPLOG
-	if(NbStarInBlock>0) {
-			
+#ifdef SSTChassLog
+	if(NbStarInBlock>0) {			
 	// On écrit les étoiles detectées
 		vector<SSTEtoile>::reverse_iterator StarVecRevIter;
@@ -266,5 +280,16 @@
 			(*StarVecRevIter).print(sstchass);
 	}
-		
+#endif
+
+#ifdef SSTStatLog
+	int nbBlockincircle=(int) (PeriodRotTeles/(archParam.acq.perEch*72.));
+//	if((compteurBlock%nbBlockincircle)==0) 
+	{
+//	if((compteurBlock%5)==0) {
+  		sststat<<numero_block(blk)<<'\t'<<nbStar<<'\t'<<noStarDet<<endl;
+  		nbStar=0;
+  	}
+  		nbStar+=NbStarInBlock;
+  		compteurBlock++;
 #endif
 
@@ -276,12 +301,10 @@
 	for(int i=0; i<NbPhotDiodBarette; i++) PisteBar[i]=new PisteEtoile(i);
 	StarHistoryMap.clear();
-#ifdef SST_DUMPLOG
 	if (!sstchassinit) {
 	  sstchass<<LastStar.printHeader()<<endl;
 	  sstchassinit = true;
 	}
-#endif
-	
-#ifdef SST_DEBUG	
+	
+#ifdef SSTDUMP	
 	char s[32];
 	string fileName;
@@ -301,5 +324,5 @@
 		}
 */			
-		pPisteDump[pistNumb]=new ofstream(fileName.c_str(),ios::out|ios::trunc);
+		pPisteDump[pistNumb]=new ofstream(fileName.c_str(),ios::out|ios::app);
 		
 		if(!(*pPisteDump[pistNumb]).is_open()) {
@@ -317,10 +340,10 @@
 	delete[] PisteBar;
 		
-#ifdef SST_DEBUG	
+#ifdef SSTDUMP	
 	for (int pistNumb=0; pistNumb<NbChanDump; pistNumb++) {
 		pPisteDump[pistNumb]->close();
 		delete pPisteDump[pistNumb];
 	}
-	delete 	pPisteDump;
+	delete[] pPisteDump;
 #endif
 
@@ -377,8 +400,6 @@
 {
   lastBlkNum = numero_block(blk);
-  if (prcTodo != 0) {
-    for (int i = 0; i<nb_per_block*2; i++) {
-      DecodeTMBlock(blk, i, diodeRaw[i]);
-    }
+  for (int i = 0; i<nb_per_block*2; i++) {
+    DecodeTMBlock(blk, i, diodeRaw[i]);
   }
   if (prcTodo & permDiode) {
Index: trunk/Poubelle/archTOI.old/ssthandler.h
===================================================================
--- trunk/Poubelle/archTOI.old/ssthandler.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/ssthandler.h	(revision 534)
@@ -24,9 +24,11 @@
 
 //#define SST_DEBUG
-//#define SST_DUMPLOG
-#define NbChanDump (10)
+//#define SSTDUMP
+#define SSTChassLog
+//#define SSTStatLog
+
+#define NbChanDump (3)
 #define	NbPhotDiodBarette (46)
 #define NbEtInMapMax 	(100)
-#define SSTChassLog (true)
 #define NbSampleBlock (2*nb_per_block)
 // Fin Zone findStar
@@ -46,5 +48,4 @@
   void NeedProcess(int prcMask);
   void ProcessBlock(block_type_sst*);
-  bool NeedBlocks() {return prcTodo != 0;}
 
   static void Has2Bars(bool, int elecOffset=0); // elecOffset : which wired together
@@ -63,6 +64,4 @@
   double getStarTime(int iSampl, int istar); 
   			// return star time in this sample
-  			
-  static int getDiodPermut(int i) {return diodpermut[i];}
 
 protected:
@@ -92,5 +91,5 @@
   PisteEtoile** PisteBar; 
   	
-#ifdef SST_DEBUG
+#ifdef SSTDUMP
   	ofstream** pPisteDump;
 #endif
@@ -111,4 +110,5 @@
   int noStarDet;
   int FirstSplNb(block_type_sst* blk); // Calcule l'index du premier echantillon du block analysé
+  
   static ofstream sstchass;
   static bool     sstchassinit;
Index: trunk/Poubelle/archTOI.old/ssthardware.h
===================================================================
--- trunk/Poubelle/archTOI.old/ssthardware.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/ssthardware.h	(revision 534)
@@ -1,4 +1,6 @@
 #ifndef SSTHARDWARE_SEEN
 #define SSTHARDWARE_SEEN
+
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 // Telescope SST
@@ -11,6 +13,6 @@
 
 // Paramètres du Vol
-#define PeriodRotTeles (20.)						// Periode de rotation du telescope en seconde
-
+#define PeriodRotTeles (20.)					// Periode de rotation du telescope en seconde
+//#define PeriodRotTeles (30.)					// version Kiruna
 
 #endif
Index: trunk/Poubelle/archTOI.old/sststarfinder.cc
===================================================================
--- trunk/Poubelle/archTOI.old/sststarfinder.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/sststarfinder.cc	(revision 534)
@@ -0,0 +1,252 @@
+// sststarfinder.cc
+// Eric Aubourg & Dominique Yvon        CEA/DAPNIA/SPP   octobre 1999
+
+#include "sststarfinder.h"
+#include "pisteetoile.h"
+#include "toimanager.h"
+#include "archparam.h"
+
+ofstream SSTStarFinder::sstchass("SSTChassLogFile");
+bool     SSTStarFinder::sstchassinit=false;
+
+#define sstStarCount "sstStarCount"
+#define sstStarZ     "sstStarZ"
+#define sstStarF     "sstStarF"
+#define sstStarSN    "sstStarSN"
+#define sstStarUTC   "sstStarUTC"
+
+
+SSTStarFinder::SSTStarFinder() {
+  lastFedSample = -1;
+  lastAnaSample = -1;
+  lastContSample = -1;
+  lastKeptSample = -1;
+    
+  findStarConstruct();
+  
+  TOIProducer* prod = TOIManager::findTOIProducer(TOI("sstDiode",0));
+  if (!prod) {
+    cerr << "SSTStarFinder : cannot find producer for sstDiode" << endl;
+    exit(-1);
+  }
+  
+  sstprod = dynamic_cast<TOILLSSTProducer*>(prod);
+  if (!sstprod) {
+    cerr << "SSTStarFinder : producer for sstDiode is not a TOILLSSTProducer" << endl;
+    exit(-1);
+  }
+  
+  sstprod->registerProcessor(this);
+
+  possibleTOIs.insert(TOI(sstStarCount,   TOI::all, "", "integer"));  
+  possibleTOIs.insert(TOI(sstStarZ,       TOI::all, "", "integer"));  
+  possibleTOIs.insert(TOI(sstStarF,       TOI::all, "", "ADU"));  
+  possibleTOIs.insert(TOI(sstStarSN,      TOI::all, "", "samplenum"));  
+  possibleTOIs.insert(TOI(sstStarUTC,     TOI::all, "", "hours"));  
+
+}
+
+SSTStarFinder::~SSTStarFinder(){
+  findStarDestruct();
+}
+
+string SSTStarFinder::getName() {
+  return("SSTStarFinder 1.0");
+}
+
+void SSTStarFinder::addTOI(TOI& toi, TOIAbsorber* client) {
+  TOIProducer::addTOI(toi, client);
+  TOIManager::activateLLProducer(sstprod);
+}
+
+void SSTStarFinder::Has2Bars(bool has, int eo)
+{
+  has2bars = has;
+  elecOffset = eo;
+}
+
+#ifdef SSTStatLog
+	static ofstream sststat("SSTStatLog");
+	static int compteurBlock=0;
+	static int nbStar=0;
+	#include "ssthardware.h"
+	#include "archparam.h"
+#endif
+
+void SSTStarFinder::findStarConstruct() {
+	PisteBar=new PisteEtoile*[NbPhotDiodBarette];
+	for(int i=0; i<NbPhotDiodBarette; i++) PisteBar[i]=new PisteEtoile(i);
+	StarHistoryMap.clear();
+	if (!sstchassinit) {
+	  sstchass<<SSTEtoile::printHeader()<<endl;
+	  sstchassinit = true;
+	}
+}
+
+void SSTStarFinder::findStarDestruct() {
+	for(int i=0; i<NbPhotDiodBarette; i++) {
+		delete PisteBar[i];
+	}
+	delete[] PisteBar;
+}
+
+void SSTStarFinder::dataFeed(long sampleNum, int* diodeSignal) {
+  if (producedTOIs.empty()) return;
+  if (sampleNum == lastFedSample+1) {
+	for(int i=0;i<NbPhotDiodBarette; i++) {	
+      PisteBar[i]->push(diodeSignal+i,1);
+    }
+    lastFedSample++;
+  } else {
+	for(int i=0;i<NbPhotDiodBarette; i++) {	
+      PisteBar[i]->fill(diodeSignal+i,sampleNum,1);
+    }
+    lastFedSample = lastContSample = sampleNum;
+  }
+  
+  if ((sampleNum >= lastAnaSample+8) && (sampleNum - lastContSample >= 40)) {
+    lastAnaSample = sampleNum;
+    if (lastKeptSample<0) lastKeptSample = sampleNum-8;
+	for(int i=0;i<NbPhotDiodBarette; i++) {	
+      if (PisteBar[i]->traque()) {				// On a trouve!
+        SSTEtoile star = PisteBar[i]->DonneEtoile();
+        StarHistoryMap[star.TEchan]=star;
+        gotStar(star);
+      }
+    }
+  }
+}
+
+void SSTStarFinder::registerProcessor(SSTStarProcessor* p) {
+  processors.push_back(p);
+  TOIManager::activateLLProducer(sstprod);
+}
+
+int SSTStarFinder::getNumbStar(int iSampl) {
+	StarHistIter IterLow=StarHistoryMap.lower_bound((double)iSampl);
+	StarHistIter IterHigh=StarHistoryMap.upper_bound((double)(iSampl+1.));
+	int Compteur=0;
+	while (!(IterLow==IterHigh)) {IterLow++; Compteur++;}
+	return Compteur;
+}
+
+double SSTStarFinder::getStarF(int iSampl, int istar){ 
+	if( (getNumbStar(iSampl)==0)||(getNumbStar(iSampl)<=istar)) return -1;
+	else {
+		StarHistIter IterLow=StarHistoryMap.lower_bound((double)iSampl);
+		while(!(istar==0)) {
+			IterLow++;
+			istar--;
+		}
+	return (double) ((*IterLow).second).InpCurrent;
+	}
+}
+
+
+int SSTStarFinder::getStarZ(int iSampl, int istar) {
+	if( (getNumbStar(iSampl)==0)||(getNumbStar(iSampl)<=istar)) return -1;
+	StarHistIter IterLow=StarHistoryMap.lower_bound((double)iSampl);
+	while(!(istar==0)) {
+		IterLow++;
+		istar--;
+	}
+	return ((*IterLow).second).NoDiode;
+}
+
+double SSTStarFinder::getStarTime(int iSampl, int istar) {
+	if( (getNumbStar(iSampl)==0)||(getNumbStar(iSampl)<=istar)) return -1;
+	StarHistIter IterLow=StarHistoryMap.lower_bound((double)iSampl);
+	while(!(istar==0)) {
+		IterLow++;
+		istar--;
+	}
+	return ((*IterLow).second).TEchan;
+}
+
+
+void SSTStarFinder::gotStar(SSTEtoile const& star) {
+  for (vector<SSTStarProcessor*>::iterator i = processors.begin(); 
+       i != processors.end(); i++) {
+      (*i)->dataFeed(star);    
+  }
+}
+
+
+// $CHECK$ we handle correctly only the first star
+long SSTStarFinder::firstSampleNum(TOI const&) {
+  if (StarHistoryMap.empty()) return -1;
+  StarHistIter i = StarHistoryMap.begin();
+  return floor((*i).second.TEchan);
+}
+
+long SSTStarFinder::lastSampleNum(TOI const&) {
+  if (StarHistoryMap.empty()) return -1;
+  StarHistIter i = StarHistoryMap.end();
+  i--;
+  return floor((*i).second.TEchan);
+}
+  
+bool SSTStarFinder::canGetValue(long sampleNum, TOI const& toi) {
+  if (sampleNum < lastKeptSample) return false;
+  if (sampleNum > lastAnaSample) return false;
+  if (toi.name == sstStarCount) return true;
+  if (getNumbStar(sampleNum) > toi.index) return true;
+  return false;
+}
+
+// $CHECK$ not done properly, complicated !!!
+bool SSTStarFinder::canGetPrevValue(long sampleNum, TOI const& toi) {
+  return canGetValue(sampleNum-1, toi);
+}
+
+bool SSTStarFinder::canGetNextValue(long sampleNum, TOI const& toi) {
+  return canGetValue(sampleNum+1, toi);
+}
+
+bool SSTStarFinder::canGetValueLater(long sampleNum, TOI const&) {
+  return sampleNum > lastAnaSample;
+}
+  
+double SSTStarFinder::getPrevValue(long& sampleNum, TOI const& toi) {
+  return getValue(--sampleNum, toi);
+}
+
+double SSTStarFinder::getNextValue(long& sampleNum, TOI const& toi) {
+  return getValue(++sampleNum, toi);
+}
+
+double SSTStarFinder::getValue(long sampleNum, TOI const& toi) {
+  if (sampleNum < lastKeptSample) return -1;
+  if (sampleNum > lastAnaSample) return -1;
+  if (toi.name == sstStarCount) {
+    return getNumbStar(sampleNum);
+  }
+  if (toi.name == sstStarF) {
+    return getStarF(sampleNum, toi.index);
+  }
+  if (toi.name == sstStarZ) {
+    return getStarZ(sampleNum, toi.index);
+  }
+  if (toi.name == sstStarSN) {
+    return getStarTime(sampleNum, toi.index);
+  }
+  if (toi.name == sstStarUTC) {
+    return archParam.acq.SN2UTC(getStarTime(sampleNum, toi.index));
+  }
+
+  return -1;
+}
+
+long SSTStarFinder::wontNeedEarlier(TOI const& toi, TOIAbsorber* client, long t) {
+  long oldT = lastNeededSample[toi.ref][client];
+  if (t<oldT) return -1;
+  lastNeededSample[toi.ref][client] = t;
+  map<TOIAbsorber*, long> m = lastNeededSample[toi.ref];
+  long min=999999999L;
+  for (map<TOIAbsorber*, long>::iterator i = m.begin(); i != m.end(); i++) {
+    if ((*i).second < min) min = (*i).second;
+  }
+  while(!StarHistoryMap.empty() && (*StarHistoryMap.begin()).first < min) StarHistoryMap.erase(StarHistoryMap.begin());
+  lastKeptSample=min;
+  return min;
+}
Index: trunk/Poubelle/archTOI.old/sststarfinder.h
===================================================================
--- trunk/Poubelle/archTOI.old/sststarfinder.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/sststarfinder.h	(revision 534)
@@ -0,0 +1,106 @@
+// sststarfinder.h
+// Eric Aubourg & Dominique Yvon        CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef SSTSTARFINDER_H
+#define SSTSTARFINDER_H
+
+#include <math.h>
+#include <vector>
+#include <map>
+
+#ifndef nb_max_bolo
+#define _archeops		//  Acquisition Archeops (avec transputer) 
+#define programme
+extern "C" {
+#include "archeops.h"
+}
+#endif
+
+#include "sstetoile.h"
+#include "pisteetoile.h"
+#include "pisteetoile.h"
+
+
+//#define SST_DEBUG
+//#define SSTDUMP
+#define SSTChassLog
+//#define SSTStatLog
+
+#define NbChanDump (3)
+#define	NbPhotDiodBarette (46)
+#define NbEtInMapMax 	(100)
+#define NbSampleBlock (2*nb_per_block)
+
+#include "toillsstproducer.h"
+
+class SSTStarProcessor {
+public:
+   virtual void dataFeed(SSTEtoile const&)=0; 
+};
+
+class SSTStarFinder : public SSTDataProcessor, public TOIProducer {
+public:
+  SSTStarFinder();
+  ~SSTStarFinder();
+  
+  virtual void dataFeed(long sampleNum, int* diodeSignal); // signal for 46 diodes...
+
+  static void Has2Bars(bool, int elecOffset=0); // elecOffset : which wired together
+  string getName();
+
+  int  getNumbStar(int iSampl);	
+  			// return number of star found in sample number iSampl	
+  int  getStarZ(int iSampl, int istar); 
+  			// return diode number of the star     
+  double getStarF(int iSampl, int istar);  
+  			// return star flux in Ampère
+  double getStarTime(int iSampl, int istar); 
+  			// return star time in this sample
+
+  virtual long   firstSampleNum(TOI const&);
+  virtual long   lastSampleNum(TOI const&);
+  
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual bool   canGetPrevValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetNextValue(long sampleNum, TOI const& toi); 
+  virtual bool   canGetValueLater(long sampleNum, TOI const& toi);  // Might, later but not now
+  
+  virtual double getPrevValue(long& sampleNum, TOI const& toi);
+  virtual double getNextValue(long& sampleNum, TOI const& toi);
+  virtual double getValue(long sampleNum, TOI const& toi);
+  virtual long   wontNeedEarlier(TOI const&, TOIAbsorber* client, long);
+
+  void registerProcessor(SSTStarProcessor*);
+  void addTOI(TOI& toi, TOIAbsorber* client);
+
+protected:
+  vector<SSTStarProcessor*> processors;
+  void gotStar(SSTEtoile const& star);
+
+  long lastFedSample; // dernier samplenum vu
+  long lastAnaSample; // dernier samplenum utilise par traque
+  long lastContSample; // dernier samplenum utilise en mode fill
+  
+  PisteEtoile** PisteBar; 
+  
+  	// Are there two photoDiod Arrays and how are they connected?
+  static bool  has2bars;
+  static int   elecOffset;
+
+  map<double,SSTEtoile> StarHistoryMap;	// On stocke les étoiles de manière ordonnée en temps
+  typedef  map<double,SSTEtoile>::iterator StarHistIter;
+  typedef  map<double,SSTEtoile>::const_iterator StarConstHistIter;
+  long lastKeptSample;
+  
+  
+  static ofstream sstchass;
+  static bool     sstchassinit;
+  
+  void findStarConstruct();
+  void findStarDestruct();
+  
+  TOILLSSTProducer* sstprod;
+};
+
+
+#endif
